' This is a type of fractal from an article in Scientific American
' The article called the fractal "Hopalong".  I no longer have the
' references, but (top secret) version 16 of Fractint is going to
' have these as one of the new types! (don't tell anyone I told you!)
'-----------------
DECLARE SUB AutoScale (a!, b!, c!, max!)
DECLARE SUB SizeWindow (size!)
DECLARE SUB KeyCheck (key$)
COMMON SHARED max, kolor
xc = 640 / 2
yc = 480 / 2
numcolors = 16

SCREEN 12
DO WHILE a$ <> CHR$(27)
	CLS
	RANDOMIZE TIMER

	scale = RND * 100000: rr = RND * scale
	a = RND * rr + (RND(1) > .5)
	b = RND * rr + (RND(1) > .5)
	c = RND * rr + (RND(1) > .5)

	AutoScale a, b, c, max                            ' Get max parameter
	SizeWindow max                                    ' Adjust window size

	VIEW (8, 40)-(600, 472), , 7

	LOCATE 1, 8: PRINT "a="; a, "b="; b, "c="; c
	x = 0: y = 0: k = 1
	DO
		xx = y - SGN(x) * SQR(ABS(b * x - c))
		yy = a - x
		x = xx: y = yy
		' Read the color at this point.  Increment it by the value (max=numcolors)
		'kolor = kolor + POINT(x, y) MOD 16 + 1
		kolor = POINT(x, y) + 1
		IF kolor > numcolors THEN kolor = 1
		PSET (x, y), kolor
		KeyCheck a$
	LOOP WHILE a$ = ""
LOOP

SUB AutoScale (a, b, c, max) STATIC
	max = a: IF b > max THEN max = b: IF c > max THEN max = c
	max = max * 1.5     ' seems to need this adjustment
END SUB

SUB KeyCheck (key$) STATIC
	key$ = INKEY$
	IF key$ = CHR$(0) + CHR$(73) THEN                  ' pg up: zoom in
		max = max * .85
		CLS
		SizeWindow max
		key$ = ""
		kolor = 1
	ELSEIF key$ = CHR$(0) + CHR$(81) THEN              'pg dn: zoom back
		max = max * 1.15
		CLS
		SizeWindow max
		key$ = ""
		kolor = 1
	END IF
END SUB

SUB SizeWindow (size) STATIC
	WINDOW (-size, -size)-(size, size)
END SUB

