'Randomly places random radius spheres inside a defined area.
'
'Alan Grainger 1997

DECLARE SUB DoSphere (vn, vr, gg)
DIM SHARED g!

RANDOMIZE TIMER

CLS
PRINT "Arranges spheres into a pyramid and outputs the file pyramid.inc": PRINT
INPUT "Number of levels: ", n
OPEN "pyramid.inc" FOR OUTPUT AS #1
PRINT #1, "// ALAN'S SPHERE PYRAMID"
PRINT #1, "// *********************"
PRINT #1, ""
PRINT #1, "union"
PRINT #1, "{"
g = 1.5
r = 1
FOR i = 1 TO n
    PRINT #1, "    // Level"; i
    nl = (n * (n + 1)) / 2
    nw = (n * (n + 1) * (n + 2)) / 6
    vr = (n - i) + 1
    vn = vr
    FOR ii = 1 TO vn
        DoSphere vn, vr, i
        vr = vr - 1
    NEXT ii
NEXT i
x = (n - 1)
z = TAN((30 * (3.141592653589793# / 180))) * x
PRINT #1, USING "    translate <-##.####, 1,-##.####>"; x; z
PRINT #1, "    pigment { color rgb 1 }"
PRINT #1, "}"
CLOSE #1

SUB DoSphere (vn, vr, gg)
    x2 = (vn - vr) * 2
    x = 0
    y! = g! * (gg - 1)
    'xb! = SQR((y! * y!) / 2)
    'zb! = SQR((y! * y!) / 2)
    xb! = 1! * (gg - 1)
    zb! = .577350269# * (gg - 1)
    FOR iii = 1 TO vr
        PRINT #1, USING "    sphere { 0, 1 translate ##*x rotate-60*y translate < ##.####, ##.####, ##.####> }"; x2; x + xb!; y!; zb!
        x = x + 2
    NEXT iii
END SUB

