' Creates a 3d grid of randomly oriented "noodles".
' Program by Dan Farmer
' This was used to create the NOODLE.INC file.

DECLARE SUB WriteNoodle (x!, y!, z!)

n = 5      ' (max n^3 objects)
OPEN "noodle.inc" FOR OUTPUT AS #1

FOR z = -n TO n
    FOR y = -n TO n
        FOR x = -n TO n
            rand = INT(RND + .5) * 19.19
            IF rand > 9 THEN
                WriteNoodle x, y, z
            END IF
        NEXT x
    NEXT y
NEXT z

SUB WriteNoodle (x, y, z)
    rx = RND * 359 + 1
    ry = RND * 359 + 1
    rz = RND * 359 + 1
    PRINT #1, "object { NoodleObject ";
    PRINT #1, USING "rotate <####.####, ####.####, ####.####> "; rx; ry; rz;
    PRINT #1, USING "translate <####.####, ####.####, ####.####> "; x; y; z;
    PRINT #1, " }"
END SUB

